#include <windows.h>
#include <psapi.h>
#include <wchar.h>
#include <stdio.h>

// Link to Psapi.lib
#pragma comment(lib, "Psapi.lib")

#define ARRAY_SIZE 1024

int wmain(int argc, WCHAR **argv)
{
   LPVOID drivers[ARRAY_SIZE];
   DWORD cbNeeded;
   int cDrivers, i;
   WCHAR szDriver[ARRAY_SIZE];

   if(EnumDeviceDrivers(drivers, sizeof(drivers), &cbNeeded) && cbNeeded < sizeof(drivers))
   {
	   cDrivers = cbNeeded / sizeof(drivers[0]);

      wprintf(L"There are %d drivers:\n", cDrivers);
	  wprintf(L"Press any key for more...\n");

      for (i=0; i < cDrivers; i++)
      {
         if(GetDeviceDriverBaseName(drivers[i], szDriver, sizeof(szDriver) / sizeof(szDriver[0])))
            wprintf(L"%d: %s\n", i+1, szDriver);
		 _getwch();
      }
   }
   else
	   wprintf(L"EnumDeviceDrivers() failed; array size needed is %d\n", cbNeeded / sizeof(LPVOID));

   return 0;
}
